﻿Version=6.80
NumberOfForms=1
Form1=ConfigForm
NumberOfObjects=4
Object1=FormLib:FormLib
Object2=fmod:FMOD
Object3=TrackBar:TrackBar
Object4=VolumeBar:TrackBar
Sub designer
addform(ConfigForm,"Configure","",220,220,220)@
addcheckbox(configform,DeletionOptn,5,15,130,25,"Auto-delete query?",220,220,220,0,0,0,True,True,False,9)@
addtable(configform,ConfigTable,5,225,225,25,"",245,245,245,0,0,0,True,False,9)@
addbutton(configform,ConfigCancel,140,15,60,23,"Cancel",212,208,200,0,0,0,True,True,9)@
addbutton(configform,ConfigureOK,205,15,30,23,"OK",212,208,200,0,0,0,True,True,9)@
addbutton(configform,ButtInitFolder,5,180,115,23,"Set initial folder:",212,208,200,0,0,0,True,True,9)@
addtextbox(configform,InitialFolderTxt,5,205,230,60,"",255,255,255,0,0,0,False,True,True,9)@
addtextbox(configform,RewindTime,95,130,75,22,"00:00:30",255,255,255,0,0,0,True,False,False,9)@
addtextbox(configform,ForwardTime,95,105,75,22,"00:00:30",255,255,255,0,0,0,True,False,False,9)@
addopendialog(configform,InitialFolder,90,5,All Files|*.*)@
addnum(configform,RepeatRate,135,155,85,0,100,255,255,255,True,True)@
addlabel(configform,ButtRepeat,15,155,75,20,"Repeat rate:",220,220,220,0,0,0,True,True,9,False)@
addlabel(configform,Rewinding,15,130,75,20,"Rewind by:",220,220,220,0,0,0,True,True,9,False)@
addlabel(configform,Forwards,15,105,75,25,"Forward by:",220,220,220,0,0,0,True,True,9,False)@
addnum(configform,RewindBy,135,130,85,0,100,255,255,255,True,True)@
addnum(configform,ForwardBy,135,105,85,0,100,255,255,255,True,True)@
addlabel(configform,MoveUnit,25,75,75,25,"Move by:",220,220,220,0,0,0,True,True,9,False)@
addradiobtn(configform,TimePercentRB,155,75,65,25,"%-age",220,220,220,0,0,0,True,True,False,9)@
addradiobtn(configform,TimeRB,100,75,55,25,"Time",220,220,220,0,0,0,True,True,False,9)@
addlabel(configform,InitialVolume,10,45,110,25,"Initial volume (%)",220,220,220,0,0,0,True,True,9,False)@
addnum(configform,InitVol,135,45,85,0,100,255,255,255,True,True)@
addpanel(configform,RadioMovePanel,90,70,145,35,255,255,255,True,False)@
End Sub
@EndOfDesignText@
Sub Globals
	
	' Declare the global variables here.
	' MusicPlayer (minimize)
	ConfigFormCancel = False
	Dim Type(InitialVolume, InitialFolder, MoveUnit, _
			InitialForward, InitialRewind, ButtonRepeat, DeletionOptn) Restore
End Sub

Public Sub ReadConfig
	ConfigTable.AddCol(cString, "ConfigItem", 30)
	ConfigTable.AddCol(cString, "ConfigValue", 30)
	ConfigTable.Visible = False
	If FileExist("MusicPlayerConfig.csv") Then
		ConfigTable.LoadCSV("MusicPlayerConfig.csv", cTab, False, False)
	End If
	ConfigTable.Filter("ConfigItem='InitialVolume'")
	If ConfigTable.RowCount = 1 Then
		Main.Config.InitialVolume = ConfigTable.Cell("ConfigValue", 0)
	Else
		Main.Config.InitialVolume = 128
	End If
	ConfigTable.Filter("ConfigItem='InitialFolder'")
	If ConfigTable.RowCount = 1 Then
		Main.Config.InitialFolder = ConfigTable.Cell("ConfigValue", 0)
	Else
		Main.Config.InitialFolder = ""
	End If
	ConfigTable.Filter("ConfigItem='MoveUnit'")
	If ConfigTable.RowCount = 1 Then
		Main.Config.MoveUnit = ConfigTable.Cell("ConfigValue", 0)
	Else
		Main.Config.MoveUnit = "Time"
	End If
	ConfigTable.Filter("ConfigItem='InitialForward'")
	If ConfigTable.RowCount = 1 Then
		Main.Config.InitialForward = ConfigTable.Cell("ConfigValue", 0)
	Else
		Main.Config.InitialForward = "10"
	End If
	ConfigTable.Filter("ConfigItem='InitialRewind'")
	If ConfigTable.RowCount = 1 Then
		Main.Config.InitialRewind = ConfigTable.Cell("ConfigValue", 0)
	Else
		Main.Config.InitialRewind = "10"
	End If
	ConfigTable.Filter("ConfigItem='ButtonRepeat'")
	If ConfigTable.RowCount = 1 Then
		Main.Config.ButtonRepeat = ConfigTable.Cell("ConfigValue", 0)
	Else
		Main.Config.ButtonRepeat = "2"
	End If
	ConfigTable.Filter("ConfigItem='DeletionOptn'")
	If ConfigTable.RowCount = 1 AND ConfigTable.Cell("ConfigValue", 0) = "true" Then
		Main.Config.DeletionOptn = True
	Else
		Main.Config.DeletionOptn = False
	End If
	ConfigTable.Clear
End Sub

Public Sub ChooseConfig
	InitVol.Value = Int((Main.Config.InitialVolume + 0.5) * 100 / 255)
	Restore.InitialFolder = Main.Config.InitialFolder
	Restore.InitialVolume = Main.Config.InitialVolume
	Restore.MoveUnit = Main.Config.MoveUnit
	Restore.InitialForward = Main.Config.InitialForward
	Restore.InitialRewind = Main.Config.InitialRewind
	Restore.ButtonRepeat = Main.Config.ButtonRepeat
	Restore.DeletionOptn = Main.Config.DeletionOptn
	TimeFormat("HH:mm:ss")
	If Main.Config.MoveUnit = "%-age" Then
		TimePercentRB.Checked = True
		TimeRB.Checked = False
		ForwardBy.Value = Int(Main.Config.InitialForward + 0.5)
		RewindBy.Value = Int(Main.Config.InitialRewind + 0.5)
		ForwardTime.Visible = False
		RewindTime.Visible = False
		ForwardBy.Visible = True
		RewindBy.Visible = True
	Else
		TimePercentRB.Checked = False
		TimeRB.Checked = True
		ForwardTime.Text = Time(Main.Config.InitialForward * 10000 + TimeParse("00:00:00"))
		RewindTime.Text = Time(Main.Config.InitialRewind * 10000 + TimeParse("00:00:00"))
		ForwardTime.Visible = True
		RewindTime.Visible = True
		ForwardBy.Visible = False
		RewindBy.Visible = False
	End If
	Restore.ButtonRepeat = Main.Config.ButtonRepeat
	RepeatRate.Value = Main.Config.ButtonRepeat
	If StrLength(Main.Config.InitialFolder) > 0 AND DirExist(Main.Config.InitialFolder) Then
		InitialFolder.File = Main.Config.InitialFolder & "\*"	' Where musicfiles?
	End If
	Restore.InitialFolder = Main.Config.InitialFolder
	InitialFolderTxt.Text = Main.Config.InitialFolder
	DeletionOptn.Checked = Main.Config.DeletionOptn
	
	ConfigForm.Show
End Sub

Sub ButtInitFolder_Click
	If InitialFolder.Show <> cCancel Then
		Main.Config.InitialFolder = FileDirname(InitialFolder.File)
	End If
	InitialFolderTxt.Text = Main.Config.InitialFolder
End Sub

Sub TimePercentRB_Click
	If 	Main.Config.MoveUnit = "Time" Then
'		If Main.lengthMs < 5000 Then
'			Msgbox("Cannot change to %-age without a file duration", "Music Player")
'			Return
'		End If
		If Main.lengthMs = 0 Then Main.lengthMs = 30 * 60000		'Arbitrary 30 mins in mS
		ErrorLabel (errFwdPcRb)
		timeString = ForwardTime.Text
		ticks = TimeParse(timeString) - TimeParse("00:00:00")
		If ticks = 0 Then
			Msgbox("Forward time format not valid/zero")
			Main.Config.MoveUnit = "Time"
			TimePercentRB.Checked = False
			TimeRB.Checked = True
		End If
	'	ticks = 1/10,000,000 of a second
		ForwardBy.Value = Int(ticks / (100 * Main.lengthMs) + 0.5)		'Render into %-age
		ErrorLabel (errRewPcRb)
		timeString = RewindTime.Text
		ticks = TimeParse(timeString) - TimeParse("00:00:00")
		If ticks = 0 Then
			Msgbox("Rewind time format not valid/zero")
			Main.Config.MoveUnit = "Time"
			TimePercentRB.Checked = False
			TimeRB.Checked = True
		End If
		percentage = Int(ticks / (100 * Main.lengthMs) + 0.5)		'Render into %-age
		If percentage > 100 Then percentage = 100
		RewindBy.Value = percentage
		ForwardTime.Visible = False
		RewindTime.Visible = False
		ForwardBy.Visible = True
		RewindBy.Visible = True
		Main.Config.MoveUnit = "%-age"
	End If
	Return

errFwdPcRb:
	Msgbox("Forward time format not valid")
	Main.Config.MoveUnit = "Time"
	TimePercentRB.Checked = False
	TimeRB.Checked = True
	ForwardTime.Visible = True
	RewindTime.Visible = True
	ForwardBy.Visible = False
	RewindBy.Visible = False
	Return
errRewPcRb:
	Msgbox("Rewind time format not valid")
	Main.Config.MoveUnit = "Time"
	TimePercentRB.Checked = False
	TimeRB.Checked = True
	ForwardTime.Visible = True
	RewindTime.Visible = True
	ForwardBy.Visible = False
	RewindBy.Visible = False
End Sub

Sub TimeRB_Click
	If 	Main.Config.MoveUnit = "%-age" Then
		If Main.lengthMs = 0 Then Main.lengthMs = 30 * 60000		'Arbitrary 30 mins in mS
		Main.Config.InitialForward = Main.lengthMs * ForwardBy.Value / 100		'Render into mS
		Main.Config.InitialRewind = Main.lengthMs * RewindBy.Value / 100		'Render into mS
		ForwardTime.Text = Time(Main.Config.InitialForward * 10000 + TimeParse("00:00:00"))
		RewindTime.Text = Time(Main.Config.InitialRewind * 10000 + TimeParse("00:00:00"))
		ForwardTime.Visible = True
		RewindTime.Visible = True
		ForwardBy.Visible = False
		RewindBy.Visible = False
		Main.Config.MoveUnit = "Time"
	End If
End Sub

Sub ConfigureOK_Click
	ConfigForm.Close
End Sub

Sub ConfigCancel_Click
	Main.Config.InitialFolder = Restore.InitialFolder
	Main.Config.ButtonRepeat = Restore.ButtonRepeat
	Main.Config.InitialForward = Restore.InitialForward
	Main.Config.InitialRewind = Restore.InitialRewind
	Main.Config.InitialVolume = Restore.InitialVolume
	Main.Config.MoveUnit = Restore.MoveUnit
	Main.Config.DeletionOptn = Restore.DeletionOptn
	ConfigFormCancel = True
	ConfigForm.Close
End Sub

Sub ConfigForm_Close
	If ConfigFormCancel Then
		ConfigFormCancel = False
	Else
		ConfigFormComplete
	End If
End Sub

Sub ConfigFormComplete
	TimeFormat("HH:mm:ss")
	If TimePercentRB.Checked Then
		Main.Config.MoveUnit = "%-age"
		Main.Config.InitialForward = ForwardBy.Value
		Main.Config.InitialRewind = RewindBy.Value
		Main.ForwardUnit = Int(Main.Config.InitialForward * Main.length / 100)
		Main.RewindUnit = Int(Main.Config.InitialRewind * Main.length / 100)
	Else
		Main.Config.MoveUnit = "Time"
		ErrorLabel (errForward)
		timeString = ForwardTime.Text
		ticks = TimeParse(timeString) - TimeParse("00:00:00")
		If ticks = 0 Then
			Msgbox("Forward time format not valid/zero")
			ConfigForm.CancelClose
			Return
		End If
	'	ticks = 1/10,000,000 of a second
		Main.Config.InitialForward = ticks / 10000		'Render into mS
		Main.ForwardUnit = Int(Main.length * Main.Config.InitialForward / Main.lengthMs)
		timeString = RewindTime.Text
		ticks = TimeParse(timeString) - TimeParse("00:00:00")
		If ticks = 0 Then
			Msgbox("Rewind time format not valid/zero")
			ConfigForm.CancelClose
			Return
		End If
	'	ticks = 1/10,000,000 of a second
		Main.Config.InitialRewind = ticks / 10000		'Render into mS
		Main.RewindUnit = Int(Main.length * Main.Config.InitialRewind / Main.lengthMs)
	End If
	Main.Config.InitialVolume = Int(0.5 + InitVol.Value * 255 / 100)	'Ensure rounding of %-age
	Main.Config.ButtonRepeat = RepeatRate.Value
	If Main.Config.ButtonRepeat = 0 Then Main.Config.ButtonRepeat = 0.49
	Main.ButtonRepeating.interval = Main.Config.ButtonRepeat * 1000
	Main.Config.DeletionOptn = DeletionOptn.Checked
	SetConfig
	Return
errForward:
	Msgbox("Forward time format not valid")
	ConfigForm.CancelClose
	Return
errRewind:
	Msgbox("Rewind time format not valid")
	ConfigForm.CancelClose
End Sub

Sub SetConfig
	ConfigTable.AddRow("InitialVolume", Main.Config.InitialVolume)
	ConfigTable.AddRow("InitialFolder", Main.Config.InitialFolder)
	ConfigTable.AddRow("MoveUnit", Main.Config.MoveUnit)
	ConfigTable.AddRow("InitialForward", Main.Config.InitialForward)
	ConfigTable.AddRow("InitialRewind", Main.Config.InitialRewind)
	ConfigTable.AddRow("ButtonRepeat", Main.Config.ButtonRepeat)
	ConfigTable.AddRow("DeletionOptn", Main.Config.DeletionOptn)
	ConfigTable.SaveCSV("MusicPlayerConfig.csv", cTab, False)
	ConfigTable.Clear
End Sub

