﻿Version=6.80
NumberOfForms=1
Form1=PlayListForm
NumberOfObjects=0
Sub designer
addform(PlayListForm,"Play list form","",220,220,220)@
addbutton(playlistform,ButtonTidy,170,195,60,23,"Tidy",212,208,200,0,0,0,True,True,9)@
addbutton(playlistform,ButtonDel,170,240,60,20,"'Delete'",212,208,200,0,0,0,True,False,9)@
addbutton(playlistform,ButtonKeep,170,240,60,20,"'Keep'",212,208,200,0,0,0,True,False,9)@
addbutton(playlistform,ButtonDown,75,240,80,20,"Move down",212,208,200,0,0,0,True,True,9)@
addbutton(playlistform,ButtonUp,5,240,65,20,"Move up",212,208,200,0,0,0,True,True,9)@
addbutton(playlistform,ButtonRemove,100,195,60,23,"Remove",212,208,200,0,0,0,True,True,9)@
addbutton(playlistform,ButtonStart,50,195,45,23,"Start",212,208,200,0,0,0,True,True,9)@
addbutton(playlistform,ButtonAdd,5,195,40,23,"Add",212,208,200,0,0,0,True,True,9)@
addtable(playlistform,PlayListTable,5,5,230,180,"",245,245,245,0,0,0,True,True,9)@
addpanel(playlistform,PanelButtons,0,190,240,80,187,255,187,True,True)@
End Sub
@EndOfDesignText@
Sub Globals
	'Declare the global variables here.
	ProgrammaticSelection = False
	SelectedRow = 0
	TotalRows = 0
	FilePlaying = 0		'Count from one...
	Public PlayString
End Sub

Public Sub Setup
	PlayListTable.AddCol(cNumber, "colSequence", 0, True)	'Unique = True
	If Main.Config.DeletionOptn Then
		PlayListTable.AddCol(cString, "colDeletion", 25)
	Else
		PlayListTable.AddCol(cString, "colDeletion", 0)
	End If
	PlayListTable.AddCol(cString, "colFileName", 180)
	PlayListTable.AddCol(cString, "colPathName", 500)
	If FileExist("MusicPlayerPlayList.csv") AND FileSize("MusicPlayerPlayList.csv") > 5 Then
		PlayListTable.LoadCSV("MusicPlayerPlayList.csv", cTab, False, False)
	End If
	TotalRows = PlayListTable.RowCount
	PlayListTable.TableSort("colSequence ASC")
	PlayListTable.CaseSensitive = False
	PlayListTable.HeaderVisible = False
	PlayListTable.Visible = False
	PlayString = ""
End Sub

Public Sub PlayListing
	If Main.Config.DeletionOptn Then
		PlayListTable.ColWidth("colDeletion") = 25
	Else
		PlayListTable.ColWidth("colDeletion") = 0
	End If
	PlayListTable.Visible = True
	PlayListForm.Show
	If TotalRows > 0 AND PlayListTable.SelectedCol <> "colFileName" Then
		PlayListTable.SelectCell("colFileName", PlayListTable.SelectedRow)
	End If
	ButtonVisibility
	PlayListTable.BringToFront
End Sub

Public Sub PreviousFile		'Returns name of file if any
	If FilePlaying > 1 AND FilePlaying <= TotalRows +1 Then 		'Check list not pruned!
		FilePlaying = FilePlaying -1		'Count from one...
		PlayString = " (" & FilePlaying & " of " & TotalRows & ")"
		Return Main.PlayingList(PlayListTable.Cell("colPathName", FilePlaying -1) & _
								PlayListTable.Cell("colFileName", FilePlaying -1))
	Else
		PlayString = ""
		Return ""
	End If
End Sub

Public Sub NextFile		'Returns name of file if any
	If FilePlaying <> 0 Then
		If FilePlaying < TotalRows Then
			If Main.Config.DeletionOptn AND PlayListTable.Cell("colDeletion", FilePlaying -1) = "Yes" Then
				Main.DeleteFile(False)		'No confirmation (Ahem!)
			End If
			FilePlaying = FilePlaying +1		'Count from one...
			PlayString = " (" & FilePlaying & " of " & TotalRows & ")"
			Return Main.PlayingList(PlayListTable.Cell("colPathName", FilePlaying -1) & _
									PlayListTable.Cell("colFileName", FilePlaying -1))
		Else
			If Main.Config.DeletionOptn AND PlayListTable.Cell("colDeletion", FilePlaying -1) = "Yes" Then
				Main.DeleteFile(False)		'No confirmation (Ahem!)
			End If
			If Main.Darkened Then
				Main.Darkened = False
				Main.PowerNotify.BacklightOn
			End If
			Msgbox("No subsequent file in play list")
			PlayString = ""
			Return ""
		End If
	End If
End Sub

Sub PlayListTable_SelectionChanged(columnName, rowIndex)
	If Not (ProgrammaticSelection) Then
		SelectedRow = rowIndex +1		'Don't start from zero !!!
		ButtonVisibility
		If columnName <> "colFileName" Then
			PlayListTable.SelectCell("colFileName", rowIndex)
			PlayListTable.Focus
			Return
		End If
		SelectedRow = rowIndex +1		'Don't start from zero !!!
	End If
	PlayListTable.Focus
End Sub

Sub ButtonVisibility

	ErrorLabel (errButtonVisibility)
	If TotalRows = 0 Then
		ButtonStart.Visible = False
		ButtonRemove.Visible = False
		ButtonTidy.Visible = False
		ButtonDel.Visible = False
		ButtonKeep.Visible = False
		ButtonDown.Visible = False
		ButtonUp.Visible = False
		Return
	End If

	ButtonStart.Visible = True
	ButtonRemove.Visible = True
	ButtonTidy.Visible = True

	If TotalRows = 1 Then
		ButtonDown.Visible = False
		ButtonUp.Visible = False
	Else
		If SelectedRow > 0 AND SelectedRow < TotalRows Then	'There's a following row!
			ButtonDown.Visible = True
		Else
			ButtonDown.Visible = False
		End If
		If SelectedRow > 1 Then	'There's a preceding row!
			ButtonUp.Visible = True
		Else
			ButtonUp.Visible = False
		End If
	End If

	If Main.Config.DeletionOptn Then
		If SelectedRow <> 0 And PlayListTable.Cell("colDeletion", SelectedRow -1) = "Yes" Then
			ButtonKeep.Visible = True
			ButtonDel.Visible = False
		Else
			ButtonKeep.Visible = False
			ButtonDel.Visible = True
		End If
	Else
			ButtonKeep.Visible = False
			ButtonDel.Visible = False
	End If
	Return

errButtonVisibility:
	Msgbox("SelectedRow = " & SelectedRow, "errButtonVisibility")
End Sub

Public Sub ButtonAdd_Click

	If Main.OpenDialog1.Show <> cCancel Then
		fullPath = Main.Opendialog1.File
		fileNameOnly = FileName(fullPath)
		pathSlash = FileDirname(fullPath) & "\"
		PlayListTable.Filter("colFileName='" & fileNameOnly & "' AND colPathName='" & pathSlash & "'")
		If PlayListTable.RowCount > 0 Then
			If Msgbox(fileNameOnly, "Duplicate file & path present: ignore?", cMsgboxYesNo) = cNo Then
				PlayListTable.Focus
				Return
			End If
		End If
		PlayListTable.Filter("")

		If Main.Config.DeletionOptn AND Msgbox(fileNameOnly, "Delete file after playing?", cMsgboxYesNo) = cYes Then
			deletion = "Yes"
		Else
			deletion = "No"
		End If

		PlayListTable.AddRow(TotalRows +1, deletion, fileNameOnly, pathSlash)
		TotalRows = TotalRows +1
		If SelectedRow = 0 Then
			SelectedRow = 1
			ProgrammaticSelection = True
			PlayListTable.SelectCell("colFileName", SelectedRow -1)
			ProgrammaticSelection = False
		End If
	End If

	ButtonVisibility
	PlayListTable.Focus

End Sub

Public Sub ButtonDown_Click
	If SelectedRow > 0 AND SelectedRow < TotalRows Then	'There's a following row!
		ProgrammaticSelection = True
		originalColSequence = PlayListTable.Cell("colSequence", SelectedRow -1)
		PlayListTable.Cell("colSequence", SelectedRow -1) = originalColSequence + 0.5
		PlayListTable.Cell("colSequence", SelectedRow) = originalColSequence
		PlayListTable.Cell("colSequence", SelectedRow) = originalColSequence + 1	'Re-sorted!
		SelectedRow = SelectedRow +1
		PlayListTable.SelectCell("colFileName", SelectedRow -1)
		ProgrammaticSelection = False
	End If
	ButtonVisibility
	PlayListTable.Focus
	PlayListTable.BringToFront
End Sub

Public Sub ButtonRemove_Click
	ProgrammaticSelection = True
	PlayListTable.RemoveRow(SelectedRow -1)
	TotalRows = TotalRows -1
	If SelectedRow <= TotalRows Then		'Renumbering needed
		index = SelectedRow -1						'Start at zero...
		Do While index < TotalRows
			PlayListTable.Cell("colSequence", index) = index +1
			index = index +1			'Need to go to next row
		Loop
	Else				'Renumbering not needed but perhaps new selection
		If TotalRows > 0 Then
			SelectedRow = TotalRows
			PlayListTable.SelectCell("colFileName", SelectedRow -1)
		End If
	End If

	ProgrammaticSelection = False
	ButtonVisibility
	PlayListTable.Focus
'	If SelectedRow < TotalRows Then
'	End If
End Sub

Public Sub ButtonStart_Click
	FilePlaying = 1		'Count from one...
	PlayString = " (" & FilePlaying & " of " & TotalRows & ")"
	PlayListForm.Close
	Main.PlayingList(PlayListTable.Cell("colPathName", 0) & PlayListTable.Cell("colFileName", 0))
End Sub

Public Sub ButtonUp_Click
	If TotalRows > 1 AND SelectedRow > 1 Then	'There's a preceding row!
		ProgrammaticSelection = True
		originalColSequence = PlayListTable.Cell("colSequence", SelectedRow -1)
		PlayListTable.Cell("colSequence", SelectedRow -1) = originalColSequence - 0.5
		PlayListTable.Cell("colSequence", SelectedRow -2) = originalColSequence
		PlayListTable.Cell("colSequence", SelectedRow -2) = originalColSequence - 1	'Re-sorted!
		SelectedRow = SelectedRow -1
		PlayListTable.SelectCell("colFileName", SelectedRow -1)
		ProgrammaticSelection = False
	End If
	ButtonVisibility
	PlayListTable.BringToFront
	PlayListTable.Focus
End Sub

Sub ButtonKeep_Click
	If SelectedRow > 0 Then	'There's a selected row!
		PlayListTable.Cell("colDeletion", SelectedRow -1) = "No"
		ButtonKeep.Visible = False
		ButtonDel.Visible = True
	End If
	PlayListTable.Focus
End Sub

Sub ButtonDel_Click
	If SelectedRow > 0 Then	'There's a selected row!
		PlayListTable.Cell("colDeletion", SelectedRow -1) = "Yes"
		ButtonKeep.Visible = True
		ButtonDel.Visible = False
	End If
	PlayListTable.Focus
End Sub

Sub PlayListForm_Close
	PlayListTable.SaveCSV("MusicPlayerPlayList.csv", cTab, False)
End Sub

Sub ButtonTidy_Click

	ProgrammaticSelection = True
	rowsCount = PlayListTable.RowCount
	index = 0						'Start at zero...
	Do While index < rowsCount
		If FileExist(PlayListTable.Cell("colPathName", index) & _
								PlayListTable.Cell("colFileName", index)) Then
			PlayListTable.Cell("colSequence", index) = index +1
			index = index +1			'Need to go to next row
		Else
			PlayListTable.RemoveRow(index)
			rowsCount = PlayListTable.RowCount
			If FilePlaying > index +1 Then FilePlaying = FilePlaying -1
		End If
	Loop

	ProgrammaticSelection = False
	TotalRows = PlayListTable.RowCount
	If TotalRows > 0 Then
		PlayListTable.SelectCell("colFileName", 0)
	End If
	If FilePlaying > 1 Then
		PlayString = " (" & FilePlaying & " of " & TotalRows & ")"
		Main.PlayListButton.Text = Main.PlayListButtonText & PlayString
		Main.PlayListButton.Refresh
	End If
	ButtonVisibility
	PlayListTable.Focus

End Sub